summaryrefslogtreecommitdiffstats
path: root/libraries/trilinos
diff options
context:
space:
mode:
Diffstat (limited to 'libraries/trilinos')
-rw-r--r--libraries/trilinos/README21
-rw-r--r--libraries/trilinos/slack-desc19
-rw-r--r--libraries/trilinos/trilinos.SlackBuild194
-rw-r--r--libraries/trilinos/trilinos.info10
4 files changed, 244 insertions, 0 deletions
diff --git a/libraries/trilinos/README b/libraries/trilinos/README
new file mode 100644
index 0000000000..98891cb2d2
--- /dev/null
+++ b/libraries/trilinos/README
@@ -0,0 +1,21 @@
+ The Trilinos Project is an effort to develop algorithms and enabling
+technologies within an object-oriented software framework for the
+solution of large-scale, complex multi-physics engineering and
+scientific problems. A unique design feature of Trilinos is its focus
+on packages.
+
+The package has two building methods, the default is for a single
+system (without parallelism).
+
+* The trilinos can also be compiled against individual packages
+(i.e. amd, umfpack and metis) outside of suitesparse.SlackBuild.
+** The suitesparse.SlackBuild, doesn't build metis by default.
+For that you can use the parMETIS.SlackBuild.
+For more details about dependeces the Xyce webpage.
+have a list of required depences.
+
+Optional dependences:
+For enable parallelism set PARALLEL=yes. This requires the
+ParMETIS library and a MPI implementation (openmpi or mpich).
+To enable CUDA set CUDA=yes (Additional requirements: CUDA
+SDK and CUSPARSE).
diff --git a/libraries/trilinos/slack-desc b/libraries/trilinos/slack-desc
new file mode 100644
index 0000000000..7da4c678b9
--- /dev/null
+++ b/libraries/trilinos/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |----handy-ruler------------------------------------------------------|
+trilinos: trilinos (trilinos project)
+trilinos:
+trilinos: The Trilinos Project is an effort to develop algorithms and enabling
+trilinos: technologies within an object-oriented software framework for the
+trilinos: solution of large-scale, complex multi-physics engineering and
+trilinos: scientific problems. A unique design feature of Trilinos is its focus
+trilinos: on packages.
+trilinos:
+trilinos:
+trilinos:
+trilinos:
diff --git a/libraries/trilinos/trilinos.SlackBuild b/libraries/trilinos/trilinos.SlackBuild
new file mode 100644
index 0000000000..ce2d5fe79c
--- /dev/null
+++ b/libraries/trilinos/trilinos.SlackBuild
@@ -0,0 +1,194 @@
+#!/bin/sh
+
+# Slackware build script for trilinos
+
+# Copyright 2015 Guilherme Calandrini - Madrid (Spain)
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=trilinos
+VERSION=${VERSION:-11.12.1}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i486 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i486" ]; then
+ SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION-Source
+tar jxvf $CWD/$PRGNAM-$VERSION-Source.tar.bz2
+cd $PRGNAM-$VERSION-Source
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+
+# Use CUDA SDK and CUSPARSE.
+if [ "${CUDA:-no}" == "yes" ]; then
+ OPT_DEPS="$OPT_DEPS -DTPL_ENABLE_CUDA -DTPL_ENABLE_CUSPARSE"
+fi
+
+if [ "${EXAMPLES:-yes}" == "no" ]; then
+ OPT_DEPS="$OPT_DEPS -DTrilinos_ENABLE_EXAMPLES=OFF"
+fi
+
+ CFGSERIAL="-DCMAKE_C_COMPILER=/usr/bin/gcc \
+ -DCMAKE_CXX_COMPILER=/usr/bin/g++ \
+ -DCMAKE_Fortran_COMPILER=/usr/bin/gfortran \
+ -DCMAKE_MAKE_PROGRAM=make \
+ -DTrilinos_ENABLE_NOX=ON \
+ -DNOX_ENABLE_LOCA=ON \
+ -DTrilinos_ENABLE_EpetraExt=ON \
+ -DEpetraExt_BUILD_BTF=ON \
+ -DEpetraExt_BUILD_EXPERIMENTAL=ON \
+ -DEpetraExt_BUILD_GRAPH_REORDERINGS=ON \
+ -DTrilinos_ENABLE_TrilinosCouplings=ON \
+ -DTrilinos_ENABLE_Ifpack=ON \
+ -DTrilinos_ENABLE_Isorropia=ON \
+ -DTrilinos_ENABLE_AztecOO=ON \
+ -DTrilinos_ENABLE_Belos=ON \
+ -DTrilinos_ENABLE_Teuchos=ON \
+ -DTeuchos_ENABLE_COMPLEX=ON \
+ -DTrilinos_ENABLE_Amesos=ON \
+ -DAmesos_ENABLE_KLU=ON \
+ -DAmesos_ENABLE_UMFPACK=ON \
+ -DTrilinos_ENABLE_Sacado=ON \
+ -DTrilinos_ENABLE_Kokkos=OFF \
+ -DTrilinos_ENABLE_ALL_OPTIONAL_PACKAGES=OFF \
+ -DTPL_ENABLE_AMD=ON \
+ -DAMD_LIBRARY_DIRS=/usr/lib${LIBDIRSUFFIX} \
+ -DTPL_AMD_INCLUDE_DIRS=/usr/include/suitesparce \
+ -DTPL_ENABLE_UMFPACK=ON \
+ -DUMFPACK_LIBRARY_DIRS=/usr/lib${LIBDIRSUFFIX} \
+ -DTPL_UMFPACK_INCLUDE_DIRS=/usr/include/suitesparse \
+ -DTPL_ENABLE_BLAS=ON \
+ -DTPL_ENABLE_LAPACK=ON "
+
+ CFGPARALLEL="-DCMAKE_C_COMPILER=/usr/bin/mpicc \
+ -DCMAKE_CXX_COMPILER=/usr/bin/mpic++ \
+ -DCMAKE_Fortran_COMPILER=/usr/bin/mpif77 \
+ -DCMAKE_MAKE_PROGRAM=make \
+ -DTrilinos_ENABLE_NOX=ON \
+ -DNOX_ENABLE_LOCA=ON \
+ -DTrilinos_ENABLE_EpetraExt=ON \
+ -DEpetraExt_BUILD_BTF=ON \
+ -DEpetraExt_BUILD_EXPERIMENTAL=ON \
+ -DEpetraExt_BUILD_GRAPH_REORDERINGS=ON \
+ -DTrilinos_ENABLE_TrilinosCouplings=ON \
+ -DTrilinos_ENABLE_Ifpack=ON \
+ -DTrilinos_ENABLE_ShyLU=ON \
+ -DTrilinos_ENABLE_Isorropia=ON \
+ -DTrilinos_ENABLE_AztecOO=ON \
+ -DTrilinos_ENABLE_Belos=ON \
+ -DTrilinos_ENABLE_Teuchos=ON \
+ -DTeuchos_ENABLE_COMPLEX=ON \
+ -DTrilinos_ENABLE_Amesos=ON \
+ -DAmesos_ENABLE_KLU=ON \
+ -DAmesos_ENABLE_UMFPACK=ON \
+ -DTrilinos_ENABLE_Sacado=ON \
+ -DTrilinos_ENABLE_Kokkos=OFF \
+ -DTrilinos_ENABLE_Zoltan=ON \
+ -DTrilinos_ENABLE_ALL_OPTIONAL_PACKAGES=OFF \
+ -DTPL_ENABLE_AMD=ON \
+ -DAMD_LIBRARY_DIRS=/usr/lib${LIBDIRSUFFIX} \
+ -DTPL_AMD_INCLUDE_DIRS=/usr/include/suitesparse \
+ -DTPL_ENABLE_UMFPACK=ON \
+ -DUMFPACK_LIBRARY_DIRS=/usr/lib${LIBDIRSUFFIX} \
+ -DTPL_UMFPACK_INCLUDE_DIRS=/usr/include/suitesparse \
+ -DTPL_ENABLE_BLAS=ON \
+ -DTPL_ENABLE_LAPACK=ON \
+ -DTPL_ENABLE_ParMETIS=ON \
+ -DParMETIS_LIBRARY_DIRS=/usr/lib${LIBDIRSUFFIX} \
+ -DTPL_ParMETIS_INCLUDE_DIRS=/usr/include/parmetis \
+ -DTPL_ENABLE_MPI=ON "
+
+ CFGTRILINOS=$CFGSERIAL
+ BUILDDIR=build-serial
+
+if [ "${PARALLEL:-no}" == "yes" ]; then
+ CFGTRILINOS=$CFGPARALLEL
+ BUILDDIR=build-parallel
+ SLKCFLAGS="CC=mpicc CXX=mpic++ F77=mpif77 $SLKCFLAGS"
+fi
+
+ mkdir -p $BUILDDIR
+ cd $BUILDDIR
+
+ cmake \
+ -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_Fortran_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_INSTALL_PREFIX=/usr \
+ -DTrilinos_INSTALL_LIB_DIR=/usr/lib${LIBDIRSUFFIX} \
+ -DTrilinos_INSTALL_INCLUDE_DIR=/usr/include \
+ $CFGTRILINOS \
+ $OPT_DEPS \
+ -DBUILD_SHARED_LIBS=ON \
+ -DCMAKE_BUILD_TYPE=RELEASE ..
+
+ make
+ ctest
+ make install DESTDIR=$PKG
+cd ..
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+find $PKG -name perllocal.pod -o -name ".packlist" -o -name "*.bs" | xargs rm -f || true
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a LICENSE $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/libraries/trilinos/trilinos.info b/libraries/trilinos/trilinos.info
new file mode 100644
index 0000000000..0d85013e9b
--- /dev/null
+++ b/libraries/trilinos/trilinos.info
@@ -0,0 +1,10 @@
+PRGNAM="trilinos"
+VERSION="11.12.1"
+HOMEPAGE="http://trilinos.org/"
+DOWNLOAD="https://trilinos.org/oldsite/download/files/trilinos-11.12.1-Source.tar.bz2"
+MD5SUM="13ec45c895d1c12b87f2d2286b27e09a"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES="atlas suitesparse"
+MAINTAINER="Guilherme Calandrini"
+EMAIL="g_calandrini[at]hotmail[dot]es"